Difference between revisions of "Mesh Scripting/ru"

From FreeCAD Documentation
Jump to navigation Jump to search
 
(24 intermediate revisions by 2 users not shown)
Line 1: Line 1:
 
<languages/>
 
<languages/>
<div class="mw-translate-fuzzy">
 
 
{{Docnav/ru
 
{{Docnav/ru
|[[FreeCAD Scripting Basics/ru|FreeCAD Scripting Basics]]
+
|[[Topological_data_scripting/ru|Topological data scripting]]
|[[Topological data scripting/ru|Topological data scripting]]}}
+
|[[Mesh_to_Part/ru|Mesh to Part]]
</div>
+
}}
  
 
{{TOCright}}
 
{{TOCright}}
  
<div class="mw-translate-fuzzy">
+
==Введение==
=== Введение ===
 
</div>
 
  
Прежде всего вы должны импортировать Mesh модуль:
+
Чтобы получить доступ к модулю {{incode|Mesh}}, вы должны сначала импортировать его:
  
 
{{Code|code=
 
{{Code|code=
Line 18: Line 15:
 
}}
 
}}
  
После этого вы получаете доступ к Mesh модулю и классам Mesh которые сообщаются с с функциями FreeCAD C++ Mesh-Kernel.
+
==Создание==
  
<div class="mw-translate-fuzzy">
+
Чтобы создать пустой объект сетки, просто используйте стандартный конструктор:
=== Создание и Загрузка ===
 
Чтобы создать простейший полигонный(сеточный) объект, просто используйте стандартный конструктор:
 
</div>
 
  
 
{{Code|code=
 
{{Code|code=
Line 29: Line 23:
 
}}
 
}}
  
Вы также можете создать объект из файла
+
Вы также можете создать объект из файла:
  
 
{{Code|code=
 
{{Code|code=
mesh = Mesh.Mesh('D:/temp/Something.stl')
+
mesh = Mesh.Mesh("D:/temp/Something.stl")
 
}}
 
}}
 
Какие файловые форматы вы можете использовать для создания полигиональных объектов написано  [[Feature_list#Key features|здесь]].
 
  
 
Или создайте его из  множества треугольников, задав их вершины:
 
Или создайте его из  множества треугольников, задав их вершины:
  
 
{{Code|code=
 
{{Code|code=
planarMesh = [
+
triangles = [
 
# triangle 1
 
# triangle 1
[-0.5000,-0.5000,0.0000],[0.5000,0.5000,0.0000],[-0.5000,0.5000,0.0000],
+
[-0.5000, -0.5000, 0.0000], [0.5000, 0.5000, 0.0000], [-0.5000, 0.5000, 0.0000],
 
#triangle 2
 
#triangle 2
[-0.5000,-0.5000,0.0000],[0.5000,-0.5000,0.0000],[0.5000,0.5000,0.0000],
+
[-0.5000, -0.5000, 0.0000], [0.5000, -0.5000, 0.0000], [0.5000, 0.5000, 0.0000],
 
]
 
]
planarMeshObject = Mesh.Mesh(planarMesh)
+
meshObject = Mesh.Mesh(triangles)
Mesh.show(planarMeshObject)
+
Mesh.show(meshObject)
 
}}
 
}}
  
Mesh-Ядро заботится о создании топологического правильной структуры данных сортируя
+
Ядро Mesh заботится о создании топологического правильной структуры данных, сортируя
совпадающие точки и края вместе.  
+
совпадающие точки и края.
  
Позже вы увидете как можно протестировать и изучить полигиональные(сеточные) данные.
+
[[#top|top]]
  
<div class="mw-translate-fuzzy">
+
==Моделирование==
=== Моделирование ===
 
Для создания обычной геометрии вы можете использовать Python сценарий BuildRegularGeoms.py.
 
</div>
 
  
To create regular geometries you can use the Python script BuildRegularGeoms.py.
+
Для создания правильной геометрии вы можете использовать один из методов {{incode|create*()}}. Например, тор можно создать следующим образом:
  
 
{{Code|code=
 
{{Code|code=
import BuildRegularGeoms
+
m = Mesh.createTorus(8.0, 2.0, 50)
 +
Mesh.show(m)
 
}}
 
}}
  
Этот сценарий предоставляет методы для определения простых тел вращения, таких как сферы, элипсоиды, цилиндры, тороиды и конусы. И он также обладает методом для создания простого куба.
+
Первые два  параметра определяют радиусы тороида,  а третий параметр - фактор подвыборки, как много треугольников будет создано. Чем выше это значение, тем сглаженней тело.
Чтобы создать тороид, например, следующим образом:
 
  
{{Code|code=
+
Модуль {{incode|Mesh}} также предоставляет три булевых метода: {{incode|union()}}, {{incode|intersection()}} и {{incode|difference()}}:
t = BuildRegularGeoms.Toroid(8.0, 2.0, 50) # list with several thousands triangles
 
m = Mesh.Mesh(t)
 
}}
 
 
 
Первые два  параметра определяют радиусы тороида  а третий параметр фактор подвыборки , как много треугольников будет создано. Чем выше это значение тем сглаженней и наоброт чем ниже тем грубее тело.
 
Mesh классы предоставляют набор логических функций которые могут быть использовыны в целях моделирования. Они обеспечивают объединение, пересечение и вычитание двух полигиональных объектов.
 
  
 
{{Code|code=
 
{{Code|code=
Line 89: Line 72:
 
}}
 
}}
  
Наконец, полный пример, который вычисляет пересечение сферы и цилиндра, пересекающего сферу.
+
Вот пример, который создает трубку, используя метод {{incode|difference()}}:
  
 
{{Code|code=
 
{{Code|code=
import Mesh, BuildRegularGeoms
+
import FreeCAD, Mesh
sphere = Mesh.Mesh( BuildRegularGeoms.Sphere(5.0, 50) )
+
cylA = Mesh.createCylinder(2.0, 10.0, True, 1.0, 36)
cylinder = Mesh.Mesh( BuildRegularGeoms.Cylinder(2.0, 10.0, True, 1.0, 50) )
+
cylB = Mesh.createCylinder(1.0, 12.0, True, 1.0, 36)
diff = sphere
+
cylB.Placement.Base = (FreeCAD.Vector(-1, 0, 0)) # move cylB to avoid co-planar faces
diff = diff.difference(cylinder)
+
pipe = cylA
d = FreeCAD.newDocument()
+
pipe = pipe.difference(cylB)
d.addObject("Mesh::Feature","Diff_Sphere_Cylinder").Mesh=diff
+
pipe.flipNormals() # somehow required
d.recompute()
+
doc = FreeCAD.ActiveDocument
 +
obj = d.addObject("Mesh::Feature", "Pipe")
 +
obj.Mesh = pipe
 +
doc.recompute()
 
}}
 
}}
  
<div class="mw-translate-fuzzy">
+
[[#top|top]]
=== Изучение и Тестирование ===
 
</div>
 
  
<div class="mw-translate-fuzzy">
+
==Примечания==
=== Создание собственного Алгоритма ===
 
</div>
 
  
<div class="mw-translate-fuzzy">
+
Широко применяемый, хотя и трудный в использовании, источник скриптов обработки полигональных сеток - это тестовые скрипты в модуле {{incode|Mesh}}.
=== Экспортирование ===
+
В этих  тестах модуля буквально все методы вызываются и все свойства/атрибуты перебираются.
Вы также можете записать полигиональную модель как модуль python:
 
</div>
 
 
 
{{Code|code=
 
m.write("D:/Develop/Projekte/FreeCAD/FreeCAD_0.7/Mod/Mesh/SavedMesh.py")
 
import SavedMesh
 
m2 = Mesh.Mesh(SavedMesh.faces)
 
}}
 
 
 
<div class="mw-translate-fuzzy">
 
=== Все что связано с Gui реализацией ===
 
</div>
 
 
 
<div class="mw-translate-fuzzy">
 
=== Всякая всячина ===
 
Трудно, широко использовать источники полигональной модели связанные с сценарием, все это тестирование написания сценариев для полигонального модуля
 
В этих  тестах модуля буквально все методы вызываются и все свойства/атрибуты вымышлены.
 
 
Так что если вы достаточно смелы, взгляните на [https://github.com/FreeCAD/FreeCAD/blob/master/src/Mod/Mesh/App/MeshTestsApp.py Unit Test module].
 
Так что если вы достаточно смелы, взгляните на [https://github.com/FreeCAD/FreeCAD/blob/master/src/Mod/Mesh/App/MeshTestsApp.py Unit Test module].
</div>
 
  
An extensive (though hard to use) source of Mesh related scripting are the unit test scripts of the Mesh-Module.
+
Смотрите так же: [[Mesh_API/ru|Mesh API]].
In this unit tests literally all methods are called and all properties/attributes are tweaked.
 
So if you are bold enough, take a look at the [https://github.com/FreeCAD/FreeCAD/blob/master/src/Mod/Mesh/App/MeshTestsApp.py Unit Test module].
 
  
See also [[Mesh_API|Mesh API]]
+
[[#top|top]]
  
 
{{Docnav/ru
 
{{Docnav/ru
|[[FreeCAD_Scripting_Basics/ru|FreeCAD Scripting Basics]]
 
 
|[[Topological_data_scripting/ru|Topological data scripting]]
 
|[[Topological_data_scripting/ru|Topological data scripting]]
 +
|[[Mesh_to_Part/ru|Mesh to Part]]
 
}}
 
}}
  
{{Mesh Tools navi{{#translation:}}}}
 
 
{{Powerdocnavi{{#translation:}}}}
 
{{Powerdocnavi{{#translation:}}}}
 +
[[Category:Developer Documentation{{#translation:}}]]
 
[[Category:Python Code{{#translation:}}]]
 
[[Category:Python Code{{#translation:}}]]
 +
{{Mesh Tools navi{{#translation:}}}}
 
{{clear}}
 
{{clear}}

Latest revision as of 10:39, 9 June 2020

Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎română • ‎svenska • ‎čeština • ‎русский • ‎中文(中国大陆)‎

Введение

Чтобы получить доступ к модулю Mesh, вы должны сначала импортировать его:

import Mesh

Создание

Чтобы создать пустой объект сетки, просто используйте стандартный конструктор:

mesh = Mesh.Mesh()

Вы также можете создать объект из файла:

mesh = Mesh.Mesh("D:/temp/Something.stl")

Или создайте его из множества треугольников, задав их вершины:

triangles = [
# triangle 1
[-0.5000, -0.5000, 0.0000], [0.5000, 0.5000, 0.0000], [-0.5000, 0.5000, 0.0000],
#triangle 2
[-0.5000, -0.5000, 0.0000], [0.5000, -0.5000, 0.0000], [0.5000, 0.5000, 0.0000],
]
meshObject = Mesh.Mesh(triangles)
Mesh.show(meshObject)

Ядро Mesh заботится о создании топологического правильной структуры данных, сортируя совпадающие точки и края.

top

Моделирование

Для создания правильной геометрии вы можете использовать один из методов create*(). Например, тор можно создать следующим образом:

m = Mesh.createTorus(8.0, 2.0, 50)
Mesh.show(m)

Первые два параметра определяют радиусы тороида, а третий параметр - фактор подвыборки, как много треугольников будет создано. Чем выше это значение, тем сглаженней тело.

Модуль Mesh также предоставляет три булевых метода: union(), intersection() и difference():

m1, m2              # are the input mesh objects
m3 = Mesh.Mesh(m1)  # create a copy of m1
m3.unite(m2)        # union of m1 and m2, the result is stored in m3
m4 = Mesh.Mesh(m1)
m4.intersect(m2)    # intersection of m1 and m2
m5 = Mesh.Mesh(m1)
m5.difference(m2)   # the difference of m1 and m2
m6 = Mesh.Mesh(m2)
m6.difference(m1)   # the difference of m2 and m1, usually the result is different to m5

Вот пример, который создает трубку, используя метод difference():

import FreeCAD, Mesh
cylA = Mesh.createCylinder(2.0, 10.0, True, 1.0, 36)
cylB = Mesh.createCylinder(1.0, 12.0, True, 1.0, 36)
cylB.Placement.Base = (FreeCAD.Vector(-1, 0, 0)) # move cylB to avoid co-planar faces
pipe = cylA
pipe = pipe.difference(cylB)
pipe.flipNormals() # somehow required
doc = FreeCAD.ActiveDocument
obj = d.addObject("Mesh::Feature", "Pipe")
obj.Mesh = pipe
doc.recompute()

top

Примечания

Широко применяемый, хотя и трудный в использовании, источник скриптов обработки полигональных сеток - это тестовые скрипты в модуле Mesh. В этих тестах модуля буквально все методы вызываются и все свойства/атрибуты перебираются. Так что если вы достаточно смелы, взгляните на Unit Test module.

Смотрите так же: Mesh API.

top